#ifndef LINKED_LIST_HPP
#define LINKED_LIST_HPP

template<typename T>
class LinkedList{
public:

  // constructor
  LinkedList();
  
  // destructor
  ~LinkedList();

  // copy constructor
  LinkedList(const LinkedList & rhs);

  // assignment
  LinkedList & operator=(const LinkedList & rhs);

  void insert(const T & item);

private:

  template<typename U>
  struct Node{
    U data;
    Node<U> * next;

    typedef Node<U> * NodePtr;
    
    Node(): next(nullptr) {};
    Node(const U& payload): next(nullptr): data(payload) {};
  };

  Node<T> * head;
  
};


template<typename T>
LinkedList<T>::LinkedList(): head(nullptr) {}

template<typename T>
void LinkedList<T>::insert(const T & item){

  // if empty, first insert
  if(head == nullptr){
    head = new Node<T>(item);
  }
  else{
    NodePtr temp = head;
    while(temp->next != nullptr){
      temp = temp->next;
    }
    temp->next = new Node<T>(item);
  }
  
}

#endif
